  
#ifndef _agentflagger_cmpt_h_
#define _agentflagger_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/flagging/agentflagger_forward.h>

using namespace std;

namespace casac {
           


   class  agentflagger  {
       public :
agentflagger();
         ~agentflagger();
         bool done();
         bool open(const  string& msname=string(""), 
			  double ntime=0.0);
         bool selectdata( const record& config=initialize_record("") , const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& antenna=string(""), const  string& uvrange=string(""), const  string& timerange=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""));
         bool parseagentparameters( const record& aparams);
         bool init();
         record* run( bool  writeflags=true,  bool  sequential=true);
         std::vector<std::string> getflagversionlist( bool  printflags=true);
         bool printflagselection();
         bool saveflagversion(const  string& versionname=string(""), const  string& comment=string(""), const  string& merge=string(""));
         bool restoreflagversion( const std::vector<std::string>& versionname=std::vector<string>(1, ""), const  string& merge=string(""));
         bool deleteflagversion( const std::vector<std::string>& versionname=std::vector<string>(1, ""));
         bool parsemanualparameters(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& antenna=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""),  bool  autocorr=false,  bool  apply=true);
         bool parseclipparameters(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& antenna=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""), const  string& datacolumn=string("DATA"),  const std::vector<double>& clipminmax=std::vector<double>() ,  bool  clipoutside=true,  bool  channelavg=false,  const variant& chanbin = initialize_variant("1"),  bool  timeavg=false, const  string& timebin=string(""),  bool  clipzeros=false,  bool  apply=true);
         bool parsequackparameters(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& antenna=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""), const  string& quackmode=string("beg"), 
			  double quackinterval=0.0,  bool  quackincrement=false,  bool  apply=true);
         bool parseelevationparameters(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& antenna=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""), 
			  double lowerlimit=0.0, 
			  double upperlimit=90.0,  bool  apply=true);
         bool parsetfcropparameters(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& antenna=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""), 
			  double ntime=0.0,  bool  combinescans=false, const  string& datacolumn=string("DATA"), 
			  double timecutoff=4.0, 
			  double freqcutoff=3.0, const  string& timefit=string("line"), const  string& freqfit=string("poly"),  int  maxnpieces=7, const  string& flagdimension=string("freqtime"), const  string& usewindowstats=string("none"),  int  halfwin=1,  bool  extendflags=true,  bool  apply=true,  bool  channelavg=false,  const variant& chanbin = initialize_variant("1"),  bool  timeavg=false, const  string& timebin=string(""));
         bool parseextendparameters(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& antenna=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""), 
			  double ntime=0.0,  bool  combinescans=false,  bool  extendpols=true, 
			  double growtime=50.0, 
			  double growfreq=50.0,  bool  growaround=false,  bool  flagneartime=false,  bool  flagnearfreq=false,  bool  apply=true);
         bool parsesummaryparameters(const  string& field=string(""), const  string& spw=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& scan=string(""), const  string& antenna=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& intent=string(""), const  string& observation=string(""),  bool  spwchan=false,  bool  spwcorr=false,  bool  basecnt=false,  bool  fieldcnt=false, const  string& name=string(""));

      private :
#include <tools/flagging/agentflagger_private.h>
   }; 

 
}
#endif
