  
#ifndef _fitter_cmpt_h_
#define _fitter_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/scimath/fitter_forward.h>

using namespace std;

namespace casac {
           


   class  fitter  {
       public :
fitter();
         ~fitter();
         record* gauss1d( const std::vector<double>& y=std::vector<double>() ,  const std::vector<double>& x=std::vector<double>() ,  const  std::vector<bool>&  mask=std::vector<bool>() ,  const variant& pampest= initialize_variant(""),  const variant& pcenterest= initialize_variant(""),  const variant& pfwhmest= initialize_variant(""));
         record* logtranspoly( const std::vector<double>& y=std::vector<double>() ,  const std::vector<double>& x=std::vector<double>() ,  const  std::vector<bool>&  mask=std::vector<bool>() ,  const std::vector<double>& estimates=std::vector<double>() );
         record* poly( const std::vector<double>& y=std::vector<double>() ,  const std::vector<double>& x=std::vector<double>() ,  const  std::vector<bool>&  mask=std::vector<bool>() ,  const std::vector<double>& estimates=std::vector<double>() );
         record* powerlogpoly( const std::vector<double>& y=std::vector<double>() ,  const std::vector<double>& x=std::vector<double>() ,  const  std::vector<bool>&  mask=std::vector<bool>() ,  const std::vector<double>& estimates=std::vector<double>() );

      private :
#include <tools/scimath/fitter_private.h>
   }; 

 
}
#endif
