  
#ifndef _imagepol_cmpt_h_
#define _imagepol_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <image_cmpt.h>
#include <tools/images/imagepol_forward.h>

using namespace std;

namespace casac {
           


   class  imagepol  {
       public :
imagepol();
         ~imagepol();
         bool imagepoltestimage( const string& outfile=string("imagepol.iquv"),  const std::vector<double>& rm=initialize_vector(1, (double)0.0), 
			  double pa0=0.0, 
			  double sigma=0.01,  int  nx=32,  int  ny=32,  int  nf=32, 
			  double f0=1.4e9, 
			  double bw=128.0e6);
         bool complexlinpol( const string& outfile);
         bool complexfraclinpol( const string& outfile);
         
                                      casac::image* depolratio( const string& infile,  bool  debias=false, 
			  double clip=10.0, 
			  double sigma=-1,  const string& outfile=string(""));
         bool close();
         bool done();
         bool fourierrotationmeasure( const string& complex=string(""),  const string& amp=string(""),  const string& pa=string(""),  const string& real=string(""),  const string& imag=string(""),  bool  zerolag0=false);
         
                                      casac::image* fraclinpol( bool  debias=false, 
			  double clip=10.0, 
			  double sigma=-1,  const string& outfile=string(""));
         
                                      casac::image* fractotpol( bool  debias=false, 
			  double clip=10.0, 
			  double sigma=-1,  const string& outfile=string(""));
         
                                      casac::image* linpolint( bool  debias=false, 
			  double clip=10.0, 
			  double sigma=-1,  const string& outfile=string(""));
         
                                      casac::image* linpolposang( const string& outfile=string(""));
         bool makecomplex( const string& complex,  const string& real=string(""),  const string& imag=string(""),  const string& amp=string(""),  const string& phase=string(""));
         bool open( const variant& image = initialize_variant(""));
         
                                      casac::image* pol( const string& which,  bool  debias=false, 
			  double clip=10.0, 
			  double sigma=-1,  const string& outfile=string(""));
         bool rotationmeasure( const string& rm=string(""),  const string& rmerr=string(""),  const string& pa0=string(""),  const string& pa0err=string(""),  const string& nturns=string(""),  const string& chisq=string(""), 
			  double sigma=-1, 
			  double rmfg=0.0, 
			  double rmmax=0.0, 
			  double maxpaerr=1e30,  const string& plotter=string(""),  int  nx=5,  int  ny=5);
         double sigma(
			  double clip=10.0);
         
                                      casac::image* sigmadepolratio( const string& infile,  bool  debias=false, 
			  double clip=10.0, 
			  double sigma=-1,  const string& outfile=string(""));
         
                                      casac::image* sigmafraclinpol(
			  double clip=10.0, 
			  double sigma=-1,  const string& outfile=string(""));
         
                                      casac::image* sigmafractotpol(
			  double clip=10.0, 
			  double sigma=-1,  const string& outfile=string(""));
         double sigmalinpolint(
			  double clip=10.0, 
			  double sigma=-1,  const string& outfile=string(""));
         
                                      casac::image* sigmalinpolposang(
			  double clip=10.0, 
			  double sigma=-1,  const string& outfile=string(""));
         double sigmastokes( const string& which, 
			  double clip=10.0);
         double sigmastokesi(
			  double clip=10.0);
         double sigmastokesq(
			  double clip=10.0);
         double sigmastokesu(
			  double clip=10.0);
         double sigmastokesv(
			  double clip=10.0);
         double sigmatotpolint(
			  double clip=10.0, 
			  double sigma=-1);
         
                                      casac::image* stokes( const string& which,  const string& outfile=string(""));
         
                                      casac::image* stokesi( const string& outfile=string(""));
         
                                      casac::image* stokesq( const string& outfile=string(""));
         
                                      casac::image* stokesu( const string& outfile=string(""));
         
                                      casac::image* stokesv( const string& outfile=string(""));
         bool summary();
         
                                      casac::image* totpolint( bool  debias=false, 
			  double clip=10.0, 
			  double sigma=-1,  const string& outfile=string(""));

      private :
#include <tools/images/imagepol_private.h>
   }; 

 
}
#endif
