  
#ifndef _logsink_cmpt_h_
#define _logsink_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/casa/logsink_forward.h>

using namespace std;

namespace casac {
           


   class  logsink  {
       public :
logsink();
         ~logsink();
         bool origin( const string& fromwhere);
         bool processorOrigin( const string& fromwhere);
         bool filter( const string& level=string("DEBUG2"));
         void filterMsg( const std::vector<std::string>& msgList=std::vector<string>(1, ""));
         void clearFilterMsgList();
         bool post( const string& message,  const string& priority=string("INFO"),  const string& origin=string(""));
         bool postLocally( const string& message,  const string& priority=string("INFO"),  const string& origin=string(""));
         string localId();
         string version();
         string id();
         bool setglobal( bool  isglobal=true);
         bool setlogfile( const string& filename=string("casapy.log"));
         bool showconsole( bool  onconsole=false);
         string logfile();
         int ompNumThreadsTest();
         int ompGetNumThreads();
         bool ompSetNumThreads( int  numThreads=1);

      private :
#include <tools/casa/logsink_private.h>
   }; 

 
}
#endif
