  
#ifndef _measures_cmpt_h_
#define _measures_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/measures/measures_forward.h>

using namespace std;

namespace casac {
           


   class  measures  {
       public :

static record _dot_touvw;
		
static record _xyz_touvw;
		
static record _xyz_expand;
		measures();
         ~measures();
         string dirshow( const record& v);
         string show( const record& v,  bool  refcode=true);
         record* epoch( const string& rf=string("UTC"),  const variant& v0 = initialize_variant(""),  const record& off=initialize_record("") );
         record* direction( const string& rf=string("J2000"),  const variant& v0 = initialize_variant(""),  const variant& v1 = initialize_variant(""),  const record& off=initialize_record("") );
         record* getvalue( const record& v);
         string gettype( const record& v);
         string getref( const record& v);
         record* getoffset( const record& v);
         string cometname();
         string comettype();
         record* cometdist();
         record* cometangdiam();
         record* comettopo();
         bool framecomet( const string& v=string(""));
         record* position( const string& rf=string("WGS84"),  const variant& v0 = initialize_variant(""),  const variant& v1 = initialize_variant(""),  const variant& v2 = initialize_variant(""),  const record& off=initialize_record("") );
         record* observatory( const string& name=string("ALMA"));
         std::vector<std::string> obslist();
         string linelist();
         record* spectralline( const string& name=string("HI"));
         string sourcelist();
         record* source( const variant& name = initialize_variant("1934-638"));
         record* frequency( const string& rf=string("LSRK"),  const variant& v0 = initialize_variant(""),  const record& off=initialize_record("") );
         record* doppler( const string& rf=string("RADIO"),  const variant& v0 = initialize_variant(""),  const record& off=initialize_record("") );
         record* radialvelocity( const string& rf=string("LSRK"),  const variant& v0 = initialize_variant(""),  const record& off=initialize_record("") );
         record* shift( const record& v=initialize_record("") ,  const variant& offset = initialize_variant("0deg"),  const variant& pa = initialize_variant("0deg"));
         record* uvw( const string& rf=string("ITRF"),  const variant& v0 = initialize_variant(""),  const variant& v1 = initialize_variant(""),  const variant& v2 = initialize_variant(""),  const record& off=initialize_record("") );
         record* touvw( const record& v=initialize_record("") ,  record& _dot=measures::_dot_touvw,  record& _xyz=measures::_xyz_touvw);
         record* expand( const record& v=initialize_record("") ,  record& _xyz=measures::_xyz_expand);
         record* earthmagnetic( const string& rf=string("IGRF"),  const variant& v0 = initialize_variant(""),  const variant& v1 = initialize_variant(""),  const variant& v2 = initialize_variant(""),  const record& off=initialize_record("") );
         record* baseline( const string& rf=string("ITRF"),  const variant& v0 = initialize_variant(""),  const variant& v1 = initialize_variant(""),  const variant& v2 = initialize_variant(""),  const record& off=initialize_record("") );
         record* asbaseline( const record& pos);
         record* listcodes( const record& ms);
         record* measure( const record& v,  const string& rf,  const record& off=initialize_record("") );
         bool doframe( const record& v);
         bool framenow();
         string showframe();
         record* toradialvelocity( const string& rf,  const record& v0);
         record* tofrequency( const string& rf,  const record& v0,  const record& rfq);
         record* todoppler( const string& rf,  const record& v0,  const variant& rfq = initialize_variant(""));
         record* torestfrequency( const record& v0,  const record& d0);
         record* rise( const variant& crd = initialize_variant(""),  const variant& ev = initialize_variant("0.0deg"));
         record* riseset( const variant& crd,  const variant& ev = initialize_variant("0.0deg"));
         record* posangle( const record& m1,  const record& m2);
         record* separation( const record& m1,  const record& m2);
         record* addxvalue( const record& a);
         string type();
         bool done();
         bool ismeasure( const record& v);

      private :
#include <tools/measures/measures_private.h>
   }; 

 
}
#endif
