  
#ifndef _ms_cmpt_h_
#define _ms_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <table_cmpt.h>
#include <tools/ms/ms_forward.h>

using namespace std;

namespace casac {
           


   class  ms  {
       public :
ms();
         ~ms();
         bool fromfits( const string& msfile=string(""),  const string& fitsfile=string(""),  bool  nomodify=true,  bool  lock=false,  int  obstype=0,  const string& host=string(""),  bool  forcenewserver=false, const  string& antnamescheme=string("old"));
         bool fromfitsidi( const string& msfile=string(""),  const string& fitsfile=string(""),  bool  nomodify=true,  bool  lock=false,  int  obstype=0);
         bool listfits(const  string& fitsfile);
         bool createmultims(const  string& outputTableName,  const std::vector<std::string>& tables,  const std::vector<std::string>& subtables,  bool  nomodify=true,  bool  lock=false,  bool  copysubtables=false,  const std::vector<std::string>& omitsubtables=std::vector<string>(1, ""));
         bool ismultims();
         std::vector<std::string> getreferencedtables();
         variant* getfielddirmeas( const string& dircolname=string("PHASE_DIR"),  int  fieldid=0, 
			  double time=0, const  string& format=string("measure"));
         int nrow( bool  selected=false);
         bool iswritable();
         bool open( const string& thems=string(""),  bool  nomodify=true,  bool  lock=false,  bool  check=false);
         bool reset();
         bool close();
         string name();
         bool tofits( const string& fitsfile=string(""),  const string& column=string("corrected"),  const variant& field = initialize_variant(""),  const variant& spw = initialize_variant(""),  int  width=1,  const variant& baseline = initialize_variant(""),  const string& time=string(""),  const variant& scan= initialize_variant(""),  const variant& uvrange= initialize_variant(""), const  string& taql=string(""),  bool  writesyscal=false,  bool  multisource=false,  bool  combinespw=false,  bool  writestation=false,  bool  padwithflags=false,  bool  overwrite=false);
         record* summary( bool  verbose=false,  const string& listfile=string(""),  bool  listunfl=false, 
			  double cachesize=50,  bool  overwrite=false);
         record* getscansummary();
         record* getspectralwindowinfo();
         bool listhistory();
         bool writehistory( const string& message=string(""),  const string& parms=string(""),  const string& origin=string("MSHistoryHandler::addMessage()"),  const string& msname=string(""),  const string& app=string("ms"));
         record* statistics(const  string& column=string(""), const  string& complex_value=string(""),  bool  useflags=true, const  string& spw=string(""), const  string& field=string(""), const  string& baseline=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& scan=string(""), const  string& array=string(""), const  string& obs=string(""));
         record* statistics2(const  string& column=string(""), const  string& complex_value=string(""),  bool  useflags=true,  bool  useweights=false, const  string& spw=string(""), const  string& field=string(""), const  string& baseline=string(""), const  string& uvrange=string(""), const  string& time=string(""), const  string& correlation=string(""), const  string& scan=string(""), const  string& intent=string(""), const  string& array=string(""), const  string& obs=string(""), const  string& reportingaxes=string(""),  bool  timeaverage=true, const  string& timebin=string("0s"), const  string& timespan=string(""));
         record* range( const  std::vector<std::string>& items=std::vector<string>(1, ""),  bool  useflags=true,  int  blocksize=10);
         bool lister( const string& options=string(""),  const string& datacolumn=string("data"),  const string& field=string(""),  const string& spw=string(""),  const string& antenna=string(""),  const string& timerange=string(""),  const string& correlation=string(""),  const string& scan=string(""),  const string& feed=string(""),  const string& array=string(""),  const string& observation=string(""),  const string& uvrange=string(""),  const string& average=string(""),  bool  showflags=false,  const string& msselect=string(""),  int  pagerows=50,  const string& listfile=string(""));
         
                                      casac::msmetadata* metadata( float  cachesize=50);
         bool selectinit( int  datadescid=0,  bool  reset=false);
         bool msselect( const record& items=initialize_record("") ,  bool  onlyparse=false);
         record* msselectedindices();
         bool select( const record& items=initialize_record("") );
         bool selecttaql( const string& msselect=string(""));
         bool selectchannel( int  nchan=1,  int  start=0,  int  width=1,  int  inc=1);
         bool selectpolarization( const std::vector<std::string>& wantedpol=std::vector<string>(1, ""));
         bool regridspw( const string& outframe=string("LSRK"),  const string& mode=string("chan"), 
			  double restfreq=-3E30,  const string& interpolation=string("LINEAR"), 
			  double start=-3E30, 
			  double center=-3E30, 
			  double bandwidth=-1., 
			  double chanwidth=-1.,  bool  hanning=true);
         bool cvel( const string& mode=string("channel"),  int  nchan=-1,  const variant& start = initialize_variant("0"),  const variant& width = initialize_variant("1"),  const string& interp=string("linear"),  const variant& phasec = initialize_variant(""),  const variant& restfreq = initialize_variant("1.4GHz"),  const string& outframe=string(""),  const string& veltype=string("radio"),  bool  hanning=true);
         std::vector<double>cvelfreqs( const  std::vector<int>& spwids=initialize_vector(1, (int)0),  const  std::vector<int>& fieldids=initialize_vector(1, (int)0),  const string& obstime=string(""),  const string& mode=string("channel"),  int  nchan=-1,  const variant& start = initialize_variant("0"),  const variant& width = initialize_variant("1"),  const variant& phasec = initialize_variant(""),  const variant& restfreq = initialize_variant("1.4GHz"),  const string& outframe=string(""),  const string& veltype=string("radio"),  bool  verbose=true);
         record* getdata( const  std::vector<std::string>& items=std::vector<string>(1, ""),  bool  ifraxis=false,  int  ifraxisgap=0,  int  increment=1,  bool  average=false);
         bool putdata( const record& items=initialize_record("") );
         bool concatenate( const string& msfile=string(""),  const variant& freqtol = initialize_variant("1Hz"),  const variant& dirtol = initialize_variant("1mas"),  float  weightscale=1.,  int  handling=0,  const string& destmsfile=string(""),  bool  respectname=false);
         bool testconcatenate( const string& msfile=string(""),  const variant& freqtol = initialize_variant("1Hz"),  const variant& dirtol = initialize_variant("1mas"),  bool  respectname=false);
         bool virtconcatenate( const string& msfile=string(""),  const string& auxfilename=string(""),  const variant& freqtol = initialize_variant("1Hz"),  const variant& dirtol = initialize_variant("1mas"),  float  weightscale=1.,  bool  respectname=true);
         bool timesort( const string& newmsname=string(""));
         bool sort( const string& newmsname=string(""),  const  std::vector<std::string>& columns=std::vector<string>(1, ""));
         bool contsub( const string& outputms=string(""),  const variant& fitspw = initialize_variant("*"),  int  fitorder=1,  const string& combine=string(""),  const variant& spw = initialize_variant("*"),  const variant& unionspw = initialize_variant("*"),  const variant& field = initialize_variant(""),  const variant& scan = initialize_variant(""),  const string& intent=string(""),  const string& correlation=string(""),  const string& obs=string(""),  const string& whichcol=string("CORRECTED_DATA"));
         bool statwt( bool  dorms=false,  bool  byantenna=true,  bool  sepacs=true,  const variant& fitspw = initialize_variant("*"),  const variant& fitcorr = initialize_variant(""),  const string& combine=string(""),  const variant& timebin = initialize_variant("0s"),  int  minsamp=3,  const variant& field = initialize_variant(""),  const variant& spw = initialize_variant("*"),  const variant& antenna= initialize_variant(""), const  string& timerange=string(""),  const variant& scan = initialize_variant(""),  const string& intent=string(""),  const variant& array = initialize_variant(""),  const string& correlation=string(""),  const string& obs=string(""),  const string& datacolumn=string("corrected_data"));
         bool split( const string& outputms=string(""),  const variant& field = initialize_variant(""),  const variant& spw = initialize_variant("*"),  const  std::vector<int>& step=initialize_vector(1, (int)1),  const variant& baseline = initialize_variant(""),  const variant& timebin = initialize_variant("-1s"),  const string& time=string(""),  const variant& scan = initialize_variant(""),  const variant& uvrange = initialize_variant(""), const  string& taql=string(""),  const string& whichcol=string("DATA"),  const variant& tileshape = initialize_variant(""),  const variant& subarray = initialize_variant(""),  const string& combine=string(""),  const string& correlation=string(""),  const string& intent=string(""),  const string& obs=string(""));
         bool partition( const string& outputms=string(""),  const variant& field = initialize_variant(""),  const variant& spw = initialize_variant("*"),  const variant& baseline = initialize_variant(""),  const variant& timebin = initialize_variant("-1s"),  const string& time=string(""),  const variant& scan = initialize_variant(""),  const variant& uvrange = initialize_variant(""), const  string& taql=string(""),  const string& whichcol=string("DATA"),  const variant& tileshape = initialize_variant(""),  const variant& subarray = initialize_variant(""),  const string& combine=string(""),  const string& intent=string(""),  const string& obs=string(""));
         bool iterinit( const  std::vector<std::string>& columns=std::vector<string>(1, ""), 
			  double interval=0.0,  int  maxrows=0,  bool  adddefaultsortcolumns=true);
         bool iterorigin();
         bool iternext();
         bool iterend();
         bool fillbuffer(const  string& item=string(""),  bool  ifraxis=false);
         record* diffbuffer(const  string& direction=string("TIME"),  int  window=1);
         record* getbuffer();
         bool clipbuffer(
			  double pixellevel=0.0, 
			  double timelevel=0.0, 
			  double channellevel=0.0);
         string asdmref(const  string& abspath=string(""));
         bool setbufferflags( const record& flags=initialize_record("") );
         bool writebufferflags();
         bool clearbuffer();
         bool continuumsub( const variant& field = initialize_variant(""),  const variant& fitspw = initialize_variant(""),  const variant& spw = initialize_variant(""),  const variant& solint = initialize_variant("int"),  int  fitorder=0,  const string& mode=string("subtract"));
         bool done();
         record* msseltoindex(const  string& vis=string(""),  const variant& spw= initialize_variant(""),  const variant& field= initialize_variant(""),  const variant& baseline= initialize_variant(""),  const variant& time= initialize_variant(""),  const variant& scan= initialize_variant(""),  const variant& uvrange= initialize_variant(""),  const variant& observation= initialize_variant(""),  const variant& polarization= initialize_variant(""), const  string& taql=string(""));
         bool hanningsmooth( const string& datacolumn=string("corrected"));
         bool uvsub( bool  reverse=false);
         bool addephemeris( int  id=-1,  const string& ephemerisname=string(""),  const string& comment=string(""),  const variant& field = initialize_variant(""));
         record* ngetdata( const  std::vector<std::string>& items=std::vector<string>(1, ""),  bool  ifraxis=false,  int  ifraxisgap=0,  int  increment=1,  bool  average=false);
         bool niterinit( const  std::vector<std::string>& columns=std::vector<string>(1, ""), 
			  double interval=0.0,  int  maxrows=0,  bool  adddefaultsortcolumns=true);
         bool niterorigin();
         bool niternext();
         bool niterend();

      private :
#include <tools/ms/ms_private.h>
   }; 

 
}
#endif
