  
#ifndef _quanta_cmpt_h_
#define _quanta_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/casa/quanta_forward.h>

using namespace std;

namespace casac {
           


   class  quanta  {
       public :
quanta();
         ~quanta();
         record* convertfreq( const variant& v = initialize_variant("1.0"),  const string& outunit=string("Hz"));
         record* convertdop( const variant& v = initialize_variant("0.0"),  const string& outunit=string("km/s"));
         record* quantity( const variant& v,  const string& unitname=string(""));
         std::vector<double>getvalue( const variant& v);
         string getunit( const variant& v);
         record* canonical( const variant& v = initialize_variant("1.0"));
         record* canon( const variant& v);
         record* convert( const variant& v,  const variant& outunit);
         bool define( const string& name,  const variant& v = initialize_variant("1"));
         string map( const string& v=string("all"));
         record* maprec( const string& v=string("all"));
         bool fits();
         std::vector<std::string> angle( const variant& v,  int  prec=0,  const  std::vector<std::string>& form=std::vector<string>(1, ""),  bool  showform=false);
         std::vector<std::string> time( const variant& v,  int  prec=0,  const  std::vector<std::string>& form=std::vector<string>(1, ""),  bool  showform=false);
         record* add( const variant& v,  const variant& a = initialize_variant("0"));
         record* sub( const variant& v,  const variant& a = initialize_variant("0"));
         record* mul( const variant& v,  const variant& a = initialize_variant("1"));
         record* div( const variant& v,  const variant& a = initialize_variant("1"));
         record* neg( const variant& v = initialize_variant("1"));
         record* norm( const variant& v, 
			  double a=-0.5);
         bool le( const variant& v,  const variant& a = initialize_variant("0"));
         bool lt( const variant& v,  const variant& a = initialize_variant("0"));
         bool eq( const variant& v,  const variant& a = initialize_variant("0"));
         bool ne( const variant& v,  const variant& a = initialize_variant("0"));
         bool gt( const variant& v,  const variant& a = initialize_variant("0"));
         bool ge( const variant& v,  const variant& a = initialize_variant("0"));
         record* sin( const variant& v);
         record* cos( const variant& v);
         record* tan( const variant& v);
         record* asin( const variant& v);
         record* acos( const variant& v);
         record* atan( const variant& v);
         record* atan2( const variant& v,  const variant& a);
         record* abs( const variant& v);
         record* ceil( const variant& v);
         record* floor( const variant& v);
         record* log( const variant& v);
         record* log10( const variant& v);
         record* exp( const variant& v);
         record* sqrt( const variant& v);
         bool compare( const variant& v,  const variant& a);
         bool check( const string& v);
         bool checkfreq( const variant& cm);
         record* pow( const variant& v,  int  a=1);
         record* constants( const string& v=string("pi"));
         bool isangle( const variant& v);
         record* totime( const variant& v);
         record* toangle( const variant& v);
         record* splitdate( const variant& v);
         string tos( const variant& v,  int  prec=9);
         string type();
         bool done( bool  kill=false);
         record* unit( const variant& v,  const string& unitname=string(""));
         bool isquantity( const variant& v);
         bool setformat( const string& t=string(""),  const string& v=string("F"));
         string getformat( const string& t=string(""));
         string formxxx( const variant& v,  const string& format=string("dms"),  int  prec=2);

      private :
#include <tools/casa/quanta_private.h>
   }; 

 
}
#endif
