  
#ifndef _singledishms_cmpt_h_
#define _singledishms_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/singledish/singledishms_forward.h>

using namespace std;

namespace casac {
           


   class  singledishms  {
       public :
singledishms();
         ~singledishms();
         bool open(const  string& ms_name=string(""));
         bool close();
         bool done();
         string name();
         bool _scale( float  factor=1.0, const  string& datacolumn=string("data"), const  string& outfile=string(""),  bool  timeaverage=false, const  string& timebin=string("0s"), const  string& timespan=string(""));
         bool subtract_baseline(const  string& datacolumn=string("data"), const  string& outfile=string(""), const  string& bloutput=string(""),  bool  dosubtract=true,  const variant& spw= initialize_variant(""), const  string& blfunc=string("poly"),  int  order=5,  float  clip_threshold_sigma=3.0,  int  num_fitting_max=1,  bool  linefinding=false,  float  threshold=5.0,  int  avg_limit=4,  int  minwidth=4,  const std::vector<int>& edge=initialize_vector(2,(int)0, (int)0));
         bool subtract_baseline_cspline(const  string& datacolumn=string("data"), const  string& outfile=string(""), const  string& bloutput=string(""),  bool  dosubtract=true,  const variant& spw= initialize_variant(""),  int  npiece=5,  float  clip_threshold_sigma=3.0,  int  num_fitting_max=1,  bool  linefinding=false,  float  threshold=5.0,  int  avg_limit=4,  int  minwidth=4,  const std::vector<int>& edge=initialize_vector(2,(int)0, (int)0));
         bool subtract_baseline_sinusoid(const  string& datacolumn=string("data"), const  string& outfile=string(""), const  string& bloutput=string(""),  bool  dosubtract=true,  const variant& spw= initialize_variant(""),  const std::vector<int>& addwn=initialize_vector(2,(int)5, (int)7),  const std::vector<int>& rejwn=initialize_vector(2,(int)5, (int)7),  float  clip_threshold_sigma=3.0,  int  num_fitting_max=1,  bool  linefinding=false,  float  threshold=5.0,  int  avg_limit=4,  int  minwidth=4,  const std::vector<int>& edge=initialize_vector(2,(int)0, (int)0));
         bool subtract_baseline_variable(const  string& datacolumn=string("data"), const  string& outfile=string(""), const  string& bloutput=string(""),  bool  dosubtract=true,  const variant& spw= initialize_variant(""), const  string& blparam=string(""));
         bool apply_baseline_table(const  string& bltable=string(""), const  string& datacolumn=string("data"),  const variant& spw= initialize_variant(""), const  string& outfile=string(""));
         bool fit_line(const  string& datacolumn=string("data"),  const variant& spw= initialize_variant(""),  const variant& pol= initialize_variant(""), const  string& fitfunc=string("gaussian"), const  string& nfit=string("0"), const  string& tempfile=string(""), const  string& tempoutfile=string(""));
         bool set_selection( const variant& spw= initialize_variant(""),  const variant& field= initialize_variant(""),  const variant& antenna= initialize_variant(""),  const variant& timerange= initialize_variant(""),  const variant& scan= initialize_variant(""),  const variant& observation= initialize_variant(""),  const variant& polarization= initialize_variant(""),  const variant& beam= initialize_variant(""),  const variant& intent= initialize_variant(""), const  string& taql=string(""));
         bool smooth(const  string& type=string("gaussian"),  float  width=0.0, const  string& datacolumn=string("data"), const  string& outfile=string(""));
         bool importasap(const  string& invile=string(""), const  string& outfile=string(""));

      private :
#include <tools/singledish/singledishms_private.h>
   }; 

 
}
#endif
