  
#ifndef _tableplot_cmpt_h_
#define _tableplot_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/tables/tableplot_forward.h>

using namespace std;

namespace casac {
           


   class  tableplot  {
       public :
tableplot();
         ~tableplot();
         bool open( const std::vector<std::string>& tabnames=std::vector<string>(1, ""));
         bool setgui( bool  gui=false);
         bool savefig(const  string& filename=string(""),  int  dpi=-1, const  string& orientation=string(""), const  string& papertype=string(""), const  string& facecolor=string(""), const  string& edgecolor=string(""));
         bool selectdata(const  string& taqlstring=string(""));
         bool plotdata( const record& poption=initialize_record("1 1 6 0.8 1.0"),  const std::vector<std::string>& labels=std::vector<string>(1, ""),  const std::vector<std::string>& datastr=std::vector<string>(1, ""));
         bool iterplotstart( const record& poption=initialize_record("1 1 6 0.8 1.0"),  const std::vector<std::string>& labels=std::vector<string>(1, ""),  const std::vector<std::string>& datastr=std::vector<string>(1, ""),  const std::vector<std::string>& iteraxes=std::vector<string>(1, ""));
         bool replot();
         int iterplotnext();
         bool iterplotstop( bool  rmplotter=false);
         bool markregions( int  nrows=0,  int  ncols=0,  int  panel=1,  const std::vector<double>& region=initialize_vector(1, (double)0.0));
         bool flagdata();
         bool unflagdata();
         bool locatedata( const std::vector<std::string>& columnlist=std::vector<string>(1, ""));
         bool clearflags( bool  roottable=false);
         bool saveflagversion(const  string& versionname=string(""), const  string& comment=string(""), const  string& merge=string(""));
         bool restoreflagversion( const std::vector<std::string>& versionname=std::vector<string>(1, ""), const  string& merge=string(""));
         bool deleteflagversion( const std::vector<std::string>& versionname=std::vector<string>(1, ""));
         bool getflagversionlist();
         bool clearplot( int  nrows=0,  int  ncols=0,  int  panel=0);
         bool done();

      private :
#include <tools/tables/tableplot_private.h>
   }; 

 
}
#endif
