  
#ifndef _utils_cmpt_h_
#define _utils_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/utils/utils_forward.h>

using namespace std;

namespace casac {
           


   class  utils  {
       public :
utils();
         ~utils();
         bool verify( const record& input=initialize_record("") ,  const variant& xmldescriptor= initialize_variant(""),  bool  throwexecpt=false);
         bool setconstraints( const variant& xmldescriptor= initialize_variant(""));
         bool verifyparam( const record& param=initialize_record("") );
         variant* expandparam(const  string& name=string(""),  const variant& value = initialize_variant(""));
         record* torecord(const  string& input);
         string toxml( const record& input=initialize_record("") ,  bool  asfile=false, const  string& filename=string("recordas.xml"));
         string getrc(const  string& rcvar=string(""));
         bool removetable( const std::vector<std::string>& tablenames=std::vector<string>(1, ""));
         record* tableinfo(const  string& tablename=string(""));
         std::vector<std::string> lockedtables();
         record* hostinfo();
         string c_exception();
         void c_exception_clear();

      private :
#include <tools/utils/utils_private.h>
   }; 

 
}
#endif
